;
; Remember? version 2.0 (SOS) -update-
; by Jean CAROT <yhean@mailcity.com>
;
; last update: 27/04/2000
;
; Do what you want with this source, its very easy to
; understand so a good start for beginners.
;

.nolist
#include	"asm83.inc"
#include	"sos.inc"

#define	score			sram
#define	blocnum			score+2
#define	position		blocnum+1
#define	difficulty		position+1
#define	cpu_matrix		difficulty+1
#define	player_matrix		cpu_matrix+5

#define	ZLIBsprite		vector0	
#define	ZLIBrandom		vector1
#define	ZLIBhiscore		vector2

.list
.org	$9327


;=============================================
; Start of program body                      ;
;=============================================


Reset_Program:

	xor	a
	jr	z,ProgStart	; invisible to SOS
	.dw	Libs-$9327	; until INSTALL installed
	.dw	Description

ProgStart:


;--------------/ Initializ variables

	ld	h,a		; a=0
	ld	l,a
	ld	(score),hl	; hl=0000
	ld	(blocnum),a
	ld	(position),a
	dec	a		; a=255 ;)
	ld	(difficulty),a


;--------------/ Display title Pic and text

	ld	hl,titlePic
	ld	de,plotsscreen+12
	ld	bc,120
	ldir
	ld	hl,plotsscreen+(12*12)	; black line
	ld	de,plotsscreen+(12*12)+1
	ld	(hl),a
	ld	bc,12-1
	ldir
	call	_bufcopy


	ld	de,$0D10
	ld	(pencol),de
	ld	hl,MenuText
	call	_vputs
	ld	de,$2020
	ld	(pencol),de
	call	_vputs
	ld	de,$2722
	ld	(pencol),de
	call	_vputs
	ld	de,$3901
	ld	(pencol),de
	call	_vputs
	ld	hl,(HiScore)
	call	_setxxxxop2
	call	_op2_to_op1
	ld	a,6
	call	_dispop1a


;--------------/ Choose Start or Exit

MenuLoop:
	call	$4014
	cp	$36		; 2nd
	jr	z,StartGame
	cp	$38		; Del
	ret	z
	jr	MenuLoop



;--------------/ Start of game

StartGame:

	xor	a
	ld	(position),a
	ld	(blocnum),a

	call	DispScore

	ld	hl,cpu_matrix		; 5 random blocs
	ld	b,5
Randomize_matrix:
	push	bc
	ld	b,5
	call	ZLIBrandom
	ld	(hl),a
	inc	hl
	pop	bc
	djnz	Randomize_matrix



	ld	hl,cpu_matrix		; draw them out
	ld	b,5
DrawBlocs:
	push	bc
	push	hl
	ld	a,(hl)
	call	GetSprite
	ld	a,(position)
	inc	a
	ld	(position),a
	pop	hl
	inc	hl
	pop	bc
	djnz	DrawBlocs

	call	_bufcopy


	ld	a,(difficulty)		; delay you have to 
	ld	b,a			; remember the combination
delay:
	push	bc
	call	$4014
	cp	$09			; Enter
	jr	z,Player_Turn
	halt
	halt
	pop	bc
	djnz	delay
	push	bc


Player_Turn:
	pop	bc

	call	ClearSprites

	xor	a
	ld	(position),a
	ld	(blocnum),a

move_loop:
	ld	a,(blocnum)
	call	GetSprite
	call	_bufcopy
Player_loop:
	call	$4014
	cp	$04		; Up
	jr	z,SpritePlus
	cp	$01		; Down
	jr	z,SpriteMinus
	cp	$09		; Enter
	jr	z,Confirm
	cp	$38		; Del
	jp	z,CheckHiScore
	jr	Player_loop


SpritePlus:
	ld	a,(blocnum)
	cp	4
	jr	z,Player_Loop
	call	GetSprite
	ld	a,(blocnum)
	inc	a
str:	ld	(blocnum),a
	jr	move_loop

SpriteMinus:
	ld	a,(blocnum)
	or	a
	jr	z,Player_Loop
	call	GetSprite
	ld	a,(blocnum)
	dec	a
	jr	str

Confirm:
	ld	hl,player_matrix
	ld	a,(position)
	ld	e,a
	add	hl,de
	ld	a,(blocnum)
	ld	(hl),a
	ld	a,(position)
	cp	4
	jr	z,Player_Loop_Done
	inc	a
	ld	(position),a
	jr	move_loop



Player_Loop_Done:			; compare cpu_matrix and
					; player_matrix
	ld	b,5
	ld	hl,cpu_matrix
	ld	de,player_matrix
compare_matrix_loop:
	push	bc
	push	hl
	push	de
	ld	b,(hl)
	ld	a,(de)
	cp	b
	call	z,Increase_Score	; 1 good -> score=score+1
	pop	de
	pop	hl
	inc	de
	inc	hl
	pop	bc
	djnz	compare_matrix_loop


	jp	StartGame

;=============================================
; End of program body                        ;
;=============================================



;--------------/ Routines (draw sprites & score stuff)


GetSprite:
	sla	a			; a*8
	sla	a
	sla	a
	ld	e,a
	xor	a
	ld	d,a
	ld	ix,sprites
	add	ix,de
GetPosition:
	ld	hl,coords
	ld	a,(position)
	ld	e,a
	add	hl,de
	ld	a,(hl)
DrawSprite:
	ld	b,8
	ld	l,34
	jp	ZLIBsprite



ClearSprites:
	ld	hl,plotsscreen+(12*34)
	ld	de,plotsscreen+(12*34)+1
	ld	bc,(12*8)-1
	xor	a
	ld	(hl),a
	ldir
	jp	_bufcopy



DispScore:
	call	ClearSprites
	ld	a,6
	ld	(currow),a
	ld	a,3
	ld	(curcol),a
	ld	hl,PressaKey
	call	_puts
	ld	a,4
	ld	(currow),a
	ld	a,2
	ld	(curcol),a
	call	_puts
	ld	hl,(score)
	call	_dispHL
	jp	_waitkey


Increase_Score:
	ld	hl,(score)
	inc	hl
	ld	(score),hl
	ld	a,(difficulty)
	cp	3
	ret	z
	sub	4
	ld	(difficulty),a		; difficulty=difficulty-4
	ret


CheckHiScore:
	call	ClearSprites
	ld	de,(Hiscore)
	ld	hl,(score)
	call	ZLIBhiscore
	jp	nz,Reset_Program	; return if no high score
	ld	hl,(score)
	ld	(Hiscore),hl
	ld	a,4
	ld	(currow),a
	ld	a,2
	ld	(curcol),a
	ld	hl,NewHS
	call	_puts
	call	_waitkey
	jp	Reset_Program



;--------------/ Program Data (lib stuff, text and graphics)


Libs:	.db	"ZLIB",0,0,0,0,lib1,vec0	; sprite
	.db	"ZLIB",0,0,0,0,lib2,vec1	; random
	.db	"ZLIB",0,0,0,0,libD,vec2	; high score
	.db	$FF				; end of libraries table



Description:	.db	"Remember? 2.0",0
MenuText:	.db	"Jean Carot",0
		.db	"2nd-Start",0
		.db	"Del-Exit",0
		.db	"HiScore:",0
HiScore:	.dw	0			; word (2 bytes)
PressaKey:	.db	"Press a key",0
Scoretxt:	.db	"Score:",0
NewHS:		.db	"New HiScore!",0

coords:		.db	12,28,44,60,76



sprites:
	.db	%11111111
	.db	%10001111
	.db	%10001111
	.db	%10001111
	.db	%11110001
	.db	%11110001
	.db	%11110001
	.db	%11111111

	.db	%11111111
	.db	%10111111
	.db	%10011111
	.db	%10001111
	.db	%10000111
	.db	%11000011
	.db	%11100001
	.db	%11111111

	.db	%11111111
	.db	%10101011
	.db	%11010101
	.db	%10101011
	.db	%11010101
	.db	%10101011
	.db	%11010101
	.db	%11111111

	.db	%11111111
	.db	%11101001
	.db	%11010001
	.db	%10100011
	.db	%11000101
	.db	%10001011
	.db	%10010111
	.db	%11111111

	.db	%11111111
	.db	%10111101
	.db	%11000011
	.db	%11011111
	.db	%11111011
	.db	%11000011
	.db	%10111101
	.db	%11111111


titlePic:
	.db	$00,$1F,$80,$00,$00,$00,$00,$0C,$00,$00,$7C,$00
	.db	$00,$18,$C0,$00,$00,$00,$00,$0C,$00,$00,$C6,$00
	.db	$00,$18,$C0,$00,$00,$00,$00,$0C,$00,$00,$06,$00
	.db	$00,$18,$C7,$8D,$D8,$78,$DD,$8D,$87,$8F,$06,$00
	.db	$00,$18,$CC,$CE,$EC,$CC,$EE,$CE,$CC,$CC,$0C,$00
	.db	$00,$1F,$8C,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$18,$00
	.db	$00,$19,$8F,$CC,$CC,$FC,$CC,$CC,$CF,$CC,$30,$00
	.db	$00,$18,$CC,$0C,$CC,$C0,$CC,$CC,$CC,$0C,$00,$00
	.db	$00,$18,$CC,$CC,$CC,$CC,$CC,$CE,$CC,$CC,$30,$00
	.db	$00,$18,$67,$8C,$CC,$78,$CC,$CD,$87,$8C,$30,$00


.end
